// MFC.cpp : Defines the class behaviors for the application.
//

//
// MFC - Vzorov aplikace WinBase602 ve Visual C++
// ===============================================
//
// Demonstruje pravu zkladn aplikace vygenerovan AppWizardem na aplikan
// program WinBase602. Program nave komunikaci s jdrem WinBase602, nastav 
// databzovou aplikaci MFC a vype pihlaovac dialogov box. Umouje otvrat 
// pohled do tabulky uveden aplikace a vedle toho bn okna tdy CMDIChildWnd.
// Ukazuje ovldn pohledu z nstrojov lity tdy CToolBar a zobrazovn
// stavovch  informac WinBase602 na stavovm dku tdy CStatusBar.
//
// Doplnno:    - Inicializace WinBase
//			    - Oteven pohledu
//              - Oeten zprv z ovldac lity pohledu
//
// Ped sputnm je teba naimportovat databzovou aplikaci MFC z adrese 
// APPLS\MFC. Programu se pedva jako prvn parametr jmno serveru nap.:
//
// MFC MujServer
//
#include "stdafx.h"
#include "MFC.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "MFCDoc.h"
#include "MFCView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMFCApp

BEGIN_MESSAGE_MAP(CMFCApp, CWinApp)
	//{{AFX_MSG_MAP(CMFCApp)
	ON_COMMAND(ID_APP_ABOUT,    OnAppAbout)
	ON_COMMAND(ID_POHLED,       OnPohled)           // Otevreni pohledu
	ON_COMMAND_EX(ID_VW_TOP,    OnPohlCommand)      // Osetreni zprav z ovladaci
	ON_COMMAND_EX(ID_VW_PGUP,   OnPohlCommand)      // listy pohledu
	ON_COMMAND_EX(ID_VW_UP,     OnPohlCommand)
	ON_COMMAND_EX(ID_VW_DN,     OnPohlCommand)
	ON_COMMAND_EX(ID_VW_PGDN,   OnPohlCommand)
	ON_COMMAND_EX(ID_VW_BOTTOM, OnPohlCommand)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW,  CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFCApp construction

CMFCApp::CMFCApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMFCApp object

CMFCApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMFCApp initialization

BOOL CMFCApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_MFCTYPE,
		RUNTIME_CLASS(CMFCDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CMFCView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

    //
    // Pkaz nepedvat, protoe parametrem je jmno WB serveru
    //
	// Dispatch commands specified on the command line
	//if (!ProcessShellCommand(cmdInfo))
	//	return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

    // Inicializace WinBase - Provede standardn navzn komunikace s jdrem,
    // zept se na jmno a heslo a nastav aplikaci MFC.
    //
    if (!*m_lpCmdLine)
    {
        MessageBox(NULL, "Na pkazov dce nen specifikovn dn server!", "Chyba", MB_OK | MB_ICONEXCLAMATION);
        return FALSE;
    }
	if (!WBAppInit("MFC", NULL, NULL, m_lpCmdLine))
		return FALSE;

	return TRUE;
}

//
// CMfcApp :: OnSetAppErr - Oeten chyby pi nastavovn aplikace
// ================================================================
//
// Vype chybov hlaen.
//
//
void CMFCApp :: OnSetAppErr()
{
    ::Info_box("MFC", "Nemohu najt aplikaci MFC!\n\n        Je naimportovan?");
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMFCApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMFCApp commands

//                                          
// CMfcApp::OnPohled - Oteven pohledu
// =====================================
//
// Vytvo instanci tdy CPohled a oteve pohled MFC.
// 
void CMFCApp::OnPohled() 
{
	// TODO: Add your command handler code here
	CPohled *Pohled = new CPohled();
	if (Pohled != NULL)
        if (Pohled->Open("*MFC"))
        	((CMainFrame *)m_pMainWnd)->SetToolBar(IDR_POHLED);
}

//
// CMfcApp::OnPohlCommand - Oeten zprv z ovldaci lity pohledu
// ================================================================
//
// Zkonvertuje ID tlatka na pslun kd zprvy a zprvu odele pohledu.
//
// Vstup:	ID	Identifiktor tlatka
//
static UINT SzmMsg[] = 
{
	SZM_FIRSTREC, 
	SZM_PREVPAGE, 
	SZM_PREVREC,
	SZM_NEXTREC,
	SZM_NEXTPAGE,
	SZM_LASTREC
} ;

BOOL CMFCApp::OnPohlCommand(UINT ID) 
{
	// TODO: Add your command handler code here
	HWND hAct = (HWND)::SendMessage(((CMDIFrameWnd *)m_pMainWnd)->m_hWndMDIClient, WM_MDIGETACTIVE, 0, 0);
	::SendMessage(hAct, SzmMsg[ID - ID_VW_TOP], 0, 0);
	return TRUE;
}
